unit ListZeichenObj;
interface
uses Grafik, Graphics, Listenunit, Basisobjekte, sysutils, Dialogs;
const
  MaxKnoten=5;
 type
  TPfeil = class(TObject)
             AnfX,AnfY, EndX, EndY:integer;
             Winkel:real;
             Papier:TZeichenflaeche;
             constructor Create(ZF:TZeichenflaeche; AX, AY, EX, EY:integer);
             procedure SetzeKoordinaten(AX,AY,EX,EY:integer);
             procedure Paint(MitSpitze:boolean);
             procedure Delete;
             destructor destroy; override;
           end;

  TListenKnoten = class(TObject)
                   X,Y,Breite, Hoehe:integer;
                   Pfeil1, Pfeil2:TPfeil;
                   Art:integer;
                   Papier:TZeichenflaeche;
                   Sichtbar:boolean;
                   Typ:integer;
                   Wert:string;
                   constructor Create(ZF:TZeichenflaeche;XP,YP,B,H,A:integer;W:string;T:integer);
                   procedure Paint;
                   destructor destroy;override;
                  end;
  TGList = class(TDList)
                MaxKnoten:integer;
                VarBreite:integer;
                DummyX, DummyY:integer;
                CurrentX, CurrentY:integer;
                DummyPfeil,CurrentPfeil, AufPfeil, AbPfeil, ListPfeil:TPfeil;
                NX,NY,IX,IY:integer;
                GrafikKnoten:array[0..MaxKnoten] of TListenKnoten;
                Papier:TZeichenflaeche;
                constructor Create(ZF:TZeichenflaeche);
                procedure add(V:TObject;S:string);
                procedure insert (V : TObject;s:string);
                procedure delete;
                procedure extract;
                procedure update(V:TObject;S:string);
                destructor destroy;override;
                procedure GrafikKnotenKopieren(von,nach:integer);
                procedure Paint;
              end;

 implementation

  constructor TPfeil.Create;
  begin
    Papier:=ZF;
    AnfX:=AX; AnfY:=AY;
    EndX:=EX; EndY:=EY;
    if EndX=AnfX then
      if EndY>AnfY then
        Winkel:=270
      else
        Winkel:=90
    else
      Winkel:=180*arctan((AnfY-EndY)/(EndX-AnfX))/Pi;
   if AnfX>EndX then
     Winkel:=Winkel+180
  end;

  procedure TPfeil.Paint(MitSpitze:boolean);
  begin
    with Papier do begin
      Stift.Hoch:=true;
      Stift.LinienBreite:=2;
      ZeichneLinie(AnfX,AnfY, EndX, EndY);
      if mitSpitze then begin
        BewegeBis(EndX,EndY);
        DreheBis(90-Winkel);
        Stift.Hoch:=false;
        DreheUm(150);
        BewegeUm(10);
        BewegeUm(-10);
        DreheBis(90-Winkel);
        DreheUm(-150);
        BewegeUm(10);
        Stift.Hoch:=true;
      end
    end
  end;

  procedure TPfeil.SetzeKoordinaten(AX,AY,EX,EY:integer);
  begin
    AnfX:=AX; AnfY:=AY;
    EndX:=EX; EndY:=EY;
    if EndX=AnfX then
      if EndY>AnfY then
        Winkel:=270
      else
        Winkel:=90
    else
      Winkel:=180*arctan((AnfY-EndY)/(EndX-AnfX))/Pi;
   if AnfX>EndX then
     Winkel:=Winkel+180
 end;

 procedure TPfeil.Delete;
 begin
 end;

 destructor TPfeil.Destroy;
 begin
 end;

 constructor TListenKnoten.Create(ZF:TZeichenflaeche;XP,YP,B,H,A:integer;W:string;T:integer);
 var
   XA,YA:integer;
 begin
   X:=XP; Y:=YP;
   Breite:=B; Hoehe:=H;
   XA:=X+Breite-Breite div 8-1;
   YA:=Y+Hoehe div 3;
   Pfeil1:=TPfeil.create(ZF,XA, YA, XA+B div 2+1,YA);
   XA:=X+Breite div 8;
   YA:=Y+Hoehe*2 div 3;
   Pfeil2:=TPfeil.Create(ZF,XA, YA, XA-B div 2-2, YA);
   WErt:=W;
   Art:=A;
   Typ:=T;
   Papier:=ZF;
 end;


   procedure TListenKnoten.Paint;
   begin
    with Papier do begin
     case Typ of
     -1:Pinsel.Fuellfarbe:=clWHite;
     0:Pinsel.Fuellfarbe:=clLime;
     1:Pinsel.Fuellfarbe:=clRed;
     2: Pinsel.Fuellfarbe:=clYellow;
     end;
     BewegeBis(X,Y);
     ZeichneRechteck(Breite div 4, Hoehe);
     BewegeBis(X+Breite div 4 - 1, Y);
     ZeichneRechteck(breite div 2, Hoehe);
     BewegeBis(X+Breite*3 div 4-2, Y);
     ZeichneRechteck(Breite div 4, Hoehe);
     if ARt<>3 then begin
       if Art<>2 then
         Pfeil1.Paint(true)
       else
         Pfeil1.Paint(false);
       if Art<>0 then
         Pfeil2.Paint(true)
       else
         Pfeil2.Paint(false)
      end else begin
            Pfeil1.paint(false);
            Pfeil2.Paint(false)
           end;
      Stift.Hoch:=true;
      BewegeBis(X+Breite div 4 +10-3*length(WErt), y+7);
      Schreibe(WErt)
    end
   end;

   destructor TListenKnoten.destroy;
   begin
   end;

   constructor TGList.Create(ZF:Tzeichenflaeche);
   var
     PaX, PaY, PeX, PeY, J:integer;
   begin
     inherited Create;
     Papier:=ZF;
     VarBreite:=50;
     DummyX:=40; DummyY:=70;
     CurrentX:=100; CurrentY:=70;
     NX:=160; NY:=70;
     IX:=220; IY:=70;
     N:=0; I:=0;
     for J:=0 to 5 do begin
        Grafikknoten[J]:=TListenKnoten.Create(Papier,40+J*77,200,56,30,3,'nil',-1);
     end;
     PaX:=DummyX+VarBreite div 2 - 1;
     PaY:=DummyY+VarBreite-10;
     PeX:=PaX-15;
     PeY:=GrafikKnoten[0].Y;
     DummyPfeil:=TPfeil.create(Papier,PaX,PaY,PeX,PeY);
     PaX:=CurrentX+VarBreite div 2 -1;
     PaY:=CurrentY+Varbreite-10;
     PeX:=DummyX + VarBreite div 2 -5;
     PeY:=grafikKnoten[0].Y;
     CurrentPfeil:=TPfeil.create(Papier,PaX,PaY,PeX,PeY);
     PaX:=grafikKnoten[0].Pfeil2.EndX+grafikknoten[0].Breite-15;
     PaY:=grafikKnoten[0].Pfeil2.EndY+30;
     PeX:=PaX;
     PeY:=Grafikknoten[0].Y+GrafikKnoten[0].Hoehe;
     AufPfeil:=TPfeil.create(Papier,PaX,PaY,PeX,PeY);
     PaX:=grafikKnoten[0].Pfeil1.EndX-grafikknoten[0].Breite+15;
     PaY:=grafikKnoten[0].Pfeil1.EndY-30;
     PeX:=PaX;
     PeY:=Grafikknoten[0].Y;
     AbPfeil:=TPfeil.create(Papier,PaX,PaY,PeX,PeY);
     ListPfeil:=TPFeil.Create(Papier,Papier.width-125,65,285,100);
   end;



 procedure TGList.add (V: TObject;s:string);
 begin
   gotoEnd;
   insert(V,S);
 end;

 procedure TGList.insert (V: TObject;S:string);
 var
   J:integer;
 begin
   inherited insert(V);
   if I>0 then begin
      for J:=N downto I+1 do
         GrafikKnotenKopieren(J-1,j);
         GrafikKnoten[I].Wert:=S;
         if V is TInteger then Grafikknoten[I].Typ:=0 else
           if V is TReal then Grafikknoten[I].Typ:=1 else
             GRafikKnoten[I].Typ:=2;
      end else  begin
            GrafikKnoten[N].Wert:=S;
              if V is TInteger then Grafikknoten[N].Typ:=0 else
               if V is TReal then Grafikknoten[N].Typ:=1 else
                 GRafikKnoten[N].Typ:=2;
           end;
 end;

 procedure TGList.extract;
 var
   J:integer;
 begin
   if N=0 then raise ListEmptyException.create('');
   if I=0 then raise ListEndException.create('');
   for J:=I to N-1 do
     GrafikKnotenKopieren(J+1,J);
   GrafikKnoten[N].sichtbar:=false;
   inherited extract;
 end;

 procedure TGList.delete;
 var
   J:integer;
 begin
   try
   gotoFirst;
   while N>0 do
     extract;
   except
     on ListEmptyexception do showmessage('Liste ist leer')
    end;
 end;



 procedure TGList.update(V:TObject;S:string);
 begin
   try
     inherited Update(V);
     GrafikKnoten[I].Wert:=S
   except
     on Listemptyexception do showMessage('Liste ist leer');
     on ListEndException do showMessage('Listenende erreicht');
   end;
 end;


 destructor TGList.destroy;
 var
  I:integer;
 begin
  DummyPfeil.destroy;
  CurrentPfeil.destroy;
  AufPfeil.destroy;
  AbPfeil.destroy;
  ListPfeil.destroy;
  for I:=0 to MaxKnoten do
     GrafikKnoten[I].destroy;
 end;

   procedure TGList.paint;
   var
     J,AX,AY,EX,EY:integer;
   begin
     with Papier do begin
     Pinsel.Fuellfarbe:=clwhite;
     Stift.Hoch:=true;
     BewegeBis(30,20);
     Font.Size:=16;
     Font.Name:='Arial';
     Stift.Hoch:=false;
     Font.Style:=[fsBold];
     Schreibe('Doppelt verkettete lineare Liste');
     Pinsel.Fuellfarbe:=clFuchsia;
     Stift.Hoch:=true;
     STift.Linienbreite:=2;
     BewegeBis(Width-150,20);
     ZeichneRechteck(50,30);
     BewegeBis(Width-150+15,27);
     Font.Size:=8;
     Schreibe('List');
     BewegeBis(width-150,49);
     ZeichneRechteck(50, 30);
     ListPfeil.Paint(true);
     BewegeBis(25,60);
     ZeichneRechteck(260,80);
      Pinsel.Fuellfarbe:=clWhite;
     BewegeBis(DummYX,DummyY);
     ZeichneRechteck(VarBreite,Varbreite-20);
     BewegeBis(DummyX+3,DummyY+7);
     Schreibe('Dummy');
     BewegeBis(DummyX,DummyY+VarBreite-21);
     ZeichneRechteck(VarBreite, VarBreite-20);
       BewegeBis(CurrentX, CurrentY);
       ZeichneRechteck(VarBreite, VarBreite-20);
       BewegeBis(CurrentX+3,CurrentY+7);
       Schreibe('Current');
       BewegeBis(CurrentX,CurrentY+VarBreite-21);
       ZeichneRechteck(VarBreite, VarBreite-20);
       BewegeBis(NX, NY);
       ZeichneRechteck(VarBreite, VarBreite-20);
       Font.Size:=10;
       BewegeBis(NX+18,NY+7);
       Schreibe('N');
       BewegeBis(NX,NY+VarBreite-21);
       ZeichneRechteck(VarBreite, VarBreite-20);
       BewegeBis(NX+20,NY+VarBreite-14);
       Schreibe(IntToStr(N));
       BewegeBis(IX, IY);
       ZeichneRechteck(VarBreite, VarBreite-20);
       BewegeBis(IX+23,IY+7);
       Schreibe('I');
       BewegeBis(IX,IY+VarBreite-21);
       ZeichneRechteck(VarBreite, VarBreite-20);
       BewegeBis(IX+20,IY+VarBreite-14);
       Schreibe(IntToStr(I));

       DummyPfeil.Paint(true);
       CurrentPfeil.SetzeKoordinaten(Currentpfeil.AnfX, CurrentPfeil.AnfY,
                                     GrafikKnoten[I].X+VarBreite div 2 - 5,
                                     CurrentPfeil.EndY);
       CurrentPfeil.Paint(true);
       if N>0 then
         GrafikKnoten[0].Art:=0
       else
         GrafikKnoten[0].Art:=3;
       for J:=1 to N do begin
         if J=N then
           GrafikKnoten[J].Art:=2
         else
           GrafikKnoten[J].Art:=1;
        end;
        for J:=0 to N do
          GrafikKnoten[J].Paint;
        AX:=Grafikknoten[0].Pfeil2.EndX;
        AY:=Grafikknoten[0].Pfeil2.EndY;
        EX:=AX;
        EY:=AY+30;
        ZeichneLinie(AX,AY,EX,EY);
        ZeichneLinie(EX,EY,EX+(N+1)*Grafikknoten[0].Breite+N*21-15,EY);
        AufPfeil.AnfX:=EX+(N+1)*Grafikknoten[0].Breite+N*21-15;
        AufPfeil.EndX:=AufPfeil.AnfX;
        AufPfeil.Paint(true);
        AX:=Grafikknoten[N].Pfeil1.EndX;
        AY:=Grafikknoten[N].Pfeil1.EndY;
        EX:=AX;
        EY:=AY-30;
        ZeichneLinie(AX,AY,EX,EY);
        ZeichneLinie(EX,EY,EX-(N+1)*Grafikknoten[0].Breite-N*21+15,EY);
        AbPfeil.AnfX:=EX-(N+1)*Grafikknoten[0].Breite-N*21+15;
        AbPfeil.EndX:=AbPfeil.AnfX;
        AbPfeil.Paint(true);
     end
   end;

   procedure TGlist.GrafikKnotenKopieren(von,nach:integer);
   begin
     GrafikKnoten[nach].Art:=GrafikKnoten[von].Art;
     GrafikKnoten[nach].Sichtbar:=true;
     GrafikKnoten[nach].Wert:=GRafikKnoten[von].Wert;
     GrafikKnoten[nach].Typ:=GRafikKnoten[von].Typ;
   end;

end.
