unit Listenunit;
interface
uses BasisObjekte, sysutils;
type
  ListEmptyException = class(Exception);
  ListEndException = class(Exception);
  TListNode = class(TObject)
                Value:TObject;
                PredP, SuccP: TListNode;
                constructor Create(V:TObject);
                function ReadValue:TObject;
                procedure WriteValue(V:TObject);
                function ReadPred:TListnode;
                function ReadSucc:TListnode;
                procedure WritePred(Pred:TListnode);
                procedure WriteSucc(Succ:TListnode);
                destructor Destroy; override;
              end;

  TDList = class(TObject)
            N,I:integer;
            Dummy, Current:TListNode;
            constructor create;
            procedure add(V:TObject);
            procedure insert (V : TObject);
            function getValue: TObject;
            procedure delete;
            procedure extract;
            procedure moveFwd;
            procedure moveBwd;
            procedure gotoEnd;
            procedure gotoFirst;
            procedure gotoLast;
            procedure gotoI (NewPos : Word);
            procedure update(V:TObject);
            function empty: Boolean;
            function atEnd: Boolean;
            function count:word;
            destructor destroy;override;
          end;

  {TStack = class(TDList)
             procedure push(P:TObject);
             function Pop:TObject;
             function Top:TObject;
             function Empty:boolean;
           end;
  }
  Implementation

  constructor tlistnode.create(V:TObject);
  begin
    value:=V;
    predp:=nil;
    succp:=nil;
  end;

  function tListnode.ReadValue:TObject;
  begin
   Result:=value
  end;

  procedure TListnode.WriteValue(V:TObject);
  begin
    Value:=V
  end;

  function TListnode.ReadPred:TListnode;
  begin
    Result:=PredP
  end;

  function TListnode.ReadSucc:TListnode;
  begin
    REsult:=SuccP
  end;

  procedure TListnode.WritePred(Pred:TListnode);
  begin
    PredP:=Pred
  end;

  procedure TListnode.WriteSucc(Succ:TListnode);
  begin
     SuccP:=Succ
  end;

  destructor TListNode.Destroy;
  begin
    if value<>nil then
      Value.destroy;
    value:=nil;
  end;

  constructor TDList.create;
  begin
    dummy:=TListnode.Create(nil);
    N := 0;
    Dummy.SuccP:=Dummy;
    Dummy.PredP:=Dummy;
    Current:=Dummy;
    I:=0;
  end;

 procedure TDList.add (V: TObject);
 var
   P:TListnode;
 begin
   P:=TListnode.Create(V);
   gotoEnd;
   Current.PredP.SuccP:=P;
   P.PredP:=Current.PredP;
   P.SuccP:=Current;
   Current.PredP:=P;
   Current := P;
   Inc(N);
 end;

 procedure TDList.insert (V: TObject);
 var
   P:TListnode;
 begin
   P:=TListnode.Create(V);
   Current.PredP.SuccP:=P;
   P.PredP:=Current.PredP;
   P.SuccP:=Current;
   Current:=P;
   Inc(I);
   Inc(N);
 end;

 procedure TDList.extract;
 var
   P:TListNode;
 begin
   if N=0 then
   raise ListEMptyException.create('Liste ist leer');
   if I=0 then raise ListEndException.Create('Listenende erreicht');
   Current.PredP.SuccP:=Current.SuccP;
   Current.SuccP.PredP:=Current.PredP;
   P:=Current;
   Current:=Current.SuccP;
   P.Destroy;
   p:=nil;
   Dec ( N );
   if I>N then
       I:=0;
 end;

 procedure TDList.delete;
 begin
   gotoEnd;
   while not empty do
     extract;
 end;

 function TDList.getValue : TObject;
 begin
   if N=0 then raise ListEmptyException.create('Liste ist leer');
   if I=0 then raise ListEndException.create('Listenende erreicht');
   result := Current.readValue
 end;

 function tDlist.count:word;
 begin
   result:=N;
 end;

 procedure TDList.gotoFirst;
 begin
   if N=0 then raise ListEmptyException.create('');
   current:=Dummy.ReadSucc;
   I:=1
 end;

 procedure TDLIst.gotoLast;
 begin
   if N=0 then raise ListEmptyException.create('');
   current:=Dummy.ReadPred;
   I:=N
 end;

 procedure TDList.gotoEnd;
 begin
   Current := Dummy;
   I       := 0
 end;

 procedure TDList.moveFwd;
 begin
 if I<N then begin
   Current := Current.SuccP;
   Inc(I);
   if I>N then I:=0;
end
end;

 procedure TDList.moveBwd;
 begin
  if I>1 then begin
   Current := Current.PredP;
   Dec(I);
   if I<0 then I:=N
  end 
 end;

 procedure TDList.gotoI (NewPos : Word);
 var
   J:integer;
 begin
  if N=0 then raise ListEmptyException.create('');
  if I>N then I:=I mod N;
  if (NewPos>0) and (NewPos<=N) then begin
   if I=0 then
     if NewPos<=N div 2 then
        for J:=1 to NewPos do
          moveFwd
     else
        for J:=1 to (N+1)-NewPos do
          moveBwd
   else
   if NewPos < I then
     for J:=1 to (I-NewPos) do
        moveBwd
   else
     for J:=1 to (NewPos-I) do
       moveFwd;
   end;
 end;

 procedure TDList.update(V:TObject);
 begin
   if N=0 then raise ListEmptyException.create('');
   if I=0 then raise ListEndException.create('');
   current.readvalue.destroy;
   current.writeValue(V)
 end;

 function TDList.atEnd : Boolean;
 begin
   result := I = 0
 end;

                              
 function TDList.empty:boolean;
 begin
    result:=N=0
 end;

 destructor TDList.destroy;
 begin
   gotoEnd;
   while not empty do
     extract;
   Dummy.destroy;
   dummy:=nil;
 end;

{   procedure TStack.push(P:TObject);
   begin
     ResetList;
     InsertList(P);
   end;

   function TStack.Pop:TObject;
   var
     ListNode:TListnode;
     S,D:TObject;
     X:integer;
   begin
     ResetList;
    S:=readList;
     Result:=S;
     DeleteNode;
   end;

   function TStack.Top:TObject;
   begin
     resetList;
     Result:=Readlist
   end;

  function TStack.Empty;
  begin
    Result:=EmptyList
  end;}

end.

