unit UListentest1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, UDVListe, ExtCtrls, Buttons,UEinlesen,
  UAusgeben, USortElement,UBasisobjekte;


type TFVerwaltung = class(TForm)
    BtnachVorne: TButton;
    BtNachHinten: TButton;
    BtAnfangListe: TButton;
    BtEndeListe: TButton;
    BtInsert: TButton;
    BtGetElement: TButton;
    BtAdd: TButton;
    BtDelete: TButton;
    EdIndex: TEdit;
    EdCount: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BtDeleteAll: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    MAusgabe: TMemo;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure BtAnfangListeClick(Sender: TObject);
    procedure BtnachVorneClick(Sender: TObject);
    procedure BtNachHintenClick(Sender: TObject);
    procedure BtEndeListeClick(Sender: TObject);
    procedure BtInsertClick(Sender: TObject);
    procedure BtGetElementClick(Sender: TObject);
    procedure BtAddClick(Sender: TObject);
    procedure BtDeleteClick(Sender: TObject);
    procedure BtDeleteAllClick(Sender: TObject);

    private
        hListe: TdvListe;
        procedure Anfangswerte;
        procedure Anzeigen;
end;

var FVerwaltung  : TFVerwaltung;
    inhalt : TSortElement;

implementation


{$R *.DFM}

(*************************** private Methoden ****************************)

procedure TFVerwaltung.Anfangswerte;
begin
  inhalt := TInteger.create(1);
  hliste.add(inhalt);
  inhalt :=TReal.create(3.21);
  hliste.add(inhalt);
  inhalt :=TString.create('test');
  hliste.add(inhalt);
  inhalt :=TBruchzahl.create(11,17);
  hliste.add(inhalt);
  inhalt :=TInteger.create(999);
  hliste.insert(inhalt)
 end;

procedure TFVerwaltung.Anzeigen;
var merk: Integer;
    aktuell:TSortElement;
begin
    merk := hListe.GetIndex;
    EdIndex.text := IntToStr(hListe.GetIndex);
    EdCount.text := IntToStr(hListe.GetCount);
    MAusgabe.Clear;
    if not hliste.isempty then begin
       MAusgabe.lines.Add ('dummy');
       hListe.first;
       while not hListe.islast do begin
         aktuell := TSortElement(hListe.GetElement);
         if merk <> hListe.GetIndex then
            MAusgabe.Lines.Add ('    '+aktuell.getText)
         else
            MAusgabe.Lines.Add ('--> '+aktuell.getText);
         hListe.next;
       end;
       aktuell := TSortElement(hListe.GetElement);
         if merk <> hListe.GetIndex then
            MAusgabe.Lines.Add ('    '+aktuell.getText)
         else
            MAusgabe.Lines.Add ('--> '+aktuell.getText);
       MAusgabe.Lines.Add ('dummy');
       hliste.first;
       while merk <> hListe.GetIndex do
          hliste.next ;
   end
end; {procedure}

(***********************  Ereignismethoden  ***********************************)

procedure TFVerwaltung.FormCreate(Sender: TObject);
begin
  hListe := TdvListe.Create;
  Anfangswerte;
  Anzeigen;
end;

procedure TFVerwaltung.BtAnfangListeClick(Sender: TObject);
begin
  hListe.first;
  anzeigen;
end;

procedure TFVerwaltung.BtnachVorneClick(Sender: TObject);
begin
    hListe.previous;
    anzeigen;
end;

procedure TFVerwaltung.BtNachHintenClick(Sender: TObject);
begin
    hListe.next;
    anzeigen;
end;

procedure TFVerwaltung.BtEndeListeClick(Sender: TObject);
begin
  hListe.last;
  anzeigen;
end;


procedure TFVerwaltung.BtInsertClick(Sender: TObject);
var
  S,N:string;
begin
    if FormEinlesen.ShowModal=mrOK then begin
        S:=FormEinlesen.edit1.text;
        N:=FormEinlesen.edit2.text;
        case FormEinlesen.Radiogroup1.itemindex of
        0: hListe.insert(TInteger.create(StrToInt(S)));
        1: hListe.insert(TBruchzahl.Create(StrToInt(S),StrToInt(N)));
        2: hListe.insert(TReal.create(StrToFloat(S)));
        3: hListe.insert(TString.create(S));
        end;
        anzeigen;
    end;
end;

procedure TFVerwaltung.BtAddClick(Sender: TObject);
var
  S,N:string;
begin
    if FormEinlesen.ShowModal=mrOK then begin
        S:=FormEinlesen.edit1.text;
        N:=FormEinlesen.edit2.text;
        case FormEinlesen.Radiogroup1.itemindex of
        0: hListe.add(TInteger.create(StrToInt(S)));
        1: hListe.add(TBruchzahl.Create(StrToInt(S),StrToInt(N)));
        2: hListe.add(TReal.create(StrToFloat(S)));
        3: hListe.add(TString.create(S));
        end;
        anzeigen;
    end;
end;

procedure TFVerwaltung.BtGetElementClick(Sender: TObject);
var
  P:TSortElement;
  Fehler:boolean;
begin
   Fehler := False;
   P:=TSortElement(hListe.GetElement);
   with FormAusgabe do begin
     EdInteger.Text:='';
     EdBruch.Text:='';
     EdReal.text:='';
     EdString.Text:='';
     if P is TInteger then EdInteger.Text:=P.GetText
     else if P is TReal then EdReal.Text:=P.GetText
          else if P is TString then EdString.Text:=P.GetText
               else if P is TBruchzahl then EdBruch.Text := P.GetText
               else Fehler:=true;
     if not Fehler then
         ShowModal
    end (* of with *)
end;


procedure TFVerwaltung.BtDeleteClick(Sender: TObject);
begin
  try
  if not hliste.isempty then
     begin
        hliste.GetElement.destroy;
        hListe.delete;
        anzeigen
     end;
  except
   ShowMessage('Delete Fehler')
  end;
end;

procedure TFVerwaltung.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try hListe.Destroy;
  except showmessage('mistfehler')
  end;
end;

procedure TFVerwaltung.BtDeleteAllClick(Sender: TObject);
begin
   hListe.DeleteAll;
   anzeigen
end;

end.
