unit UListentest1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,  ExtCtrls, Buttons,
  UEinlesen, UAusgeben, USortElement,UBasisobjekte,
  ULinListNode,ULinList;


type TFVerwaltung = class(TForm)
    BtNachHinten: TButton;
    BtAnfangListe: TButton;
    BtInsert: TButton;
    BtGetElement: TButton;
    BtInsertFirst: TButton;
    BtDeleteNext: TButton;
    EdIndex: TEdit;
    EdCount: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BtDeleteAll: TButton;
    Label3: TLabel;
    Label6: TLabel;
    MAusgabe: TMemo;
    BtDeleteFirst: TButton;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure BtAnfangListeClick(Sender: TObject);
    procedure BtNachHintenClick(Sender: TObject);
    procedure BtInsertClick(Sender: TObject);
    procedure BtGetElementClick(Sender: TObject);
    procedure BtInsertFirstClick(Sender: TObject);
    procedure BtDeleteNextClick(Sender: TObject);
    procedure BtDeleteAllClick(Sender: TObject);
    procedure BtDeleteFirstClick(Sender: TObject);

    private
        hListe: TdvListe;
        procedure Anfangswerte;
        procedure Anzeigen;
end;

var FVerwaltung  : TFVerwaltung;
    inhalt : TSortElement;

implementation


{$R *.DFM}

(*************************** private Methoden ****************************)

procedure TFVerwaltung.Anfangswerte;
begin
  inhalt := TInteger.create(1);
  hliste.insertNext(inhalt);
  inhalt :=TReal.create(3.21);
  //hliste.insertFirst(inhalt);
  inhalt :=TString.create('test');
  hliste.InsertNext(inhalt);
  inhalt :=TBruchzahl.create(11,17);
  //hliste.InsertFirst(inhalt);
  inhalt :=TInteger.create(999);
  hliste.insertNext(inhalt)
 end;

procedure TFVerwaltung.Anzeigen;
var merk: Integer;
    aktuell:TSortElement;
begin
    merk := hListe.GetIndex;
    EdIndex.text := IntToStr(hListe.GetIndex);
    EdCount.text := IntToStr(hListe.GetCount);
    MAusgabe.Clear;
    if not hliste.isempty then begin
       MAusgabe.lines.Add ('dummy');
       hListe.first;
       while not hListe.islast do begin
         aktuell := TSortElement(hListe.GetElement);
         if merk <> hListe.GetIndex then
            MAusgabe.Lines.Add ('    '+aktuell.getText)
         else
            MAusgabe.Lines.Add ('--> '+aktuell.getText);
         hListe.next;
       end;
       aktuell := TSortElement(hListe.GetElement);
         if merk <> hListe.GetIndex then
            MAusgabe.Lines.Add ('    '+aktuell.getText)
         else
            MAusgabe.Lines.Add ('--> '+aktuell.getText);
       hliste.first;
       while merk <> hListe.GetIndex do
          hliste.next ;
   end
end; {procedure}

(***********************  Ereignismethoden  ***********************************)

procedure TFVerwaltung.FormCreate(Sender: TObject);
begin
  hListe := TdvListe.Create;
  Anfangswerte;
  Anzeigen;
end;

procedure TFVerwaltung.BtAnfangListeClick(Sender: TObject);
begin
  hListe.first;
  anzeigen;
end;

procedure TFVerwaltung.BtNachHintenClick(Sender: TObject);
begin
    hListe.next;
    anzeigen;
end;

procedure TFVerwaltung.BtInsertClick(Sender: TObject);
var
  S,N:string;
begin
    if FormEinlesen.ShowModal=mrOK then begin
       try
        S:=FormEinlesen.edit1.text;
        N:=FormEinlesen.edit2.text;
        case FormEinlesen.Radiogroup1.itemindex of
        0: hListe.insertNext(TInteger.create(StrToInt(S)));
        1: hListe.insertNext(TBruchzahl.Create(StrToInt(S),StrToInt(N)));
        2: hListe.insertNext(TReal.create(StrToFloat(S)));
        3: hListe.insertNext(TString.create(S));
        end;
        anzeigen;
      except
          on EConvertError do
            case FormEinlesen.Radiogroup1.Itemindex of
              0:showmessage('Keine ganze Zahl');
              1:showmessage('Keine Dezimalzahl');
            end;
        end;
    end;
end;

procedure TFVerwaltung.BtInsertFirstClick(Sender: TObject);
var
  S,N:string;
begin
    if FormEinlesen.ShowModal=mrOK then begin
       try
        S:=FormEinlesen.edit1.text;
        N:=FormEinlesen.edit2.text;
        case FormEinlesen.Radiogroup1.itemindex of
        0: hListe.insertFirst(TInteger.create(StrToInt(S)));
        1: hListe.insertFirst(TBruchzahl.Create(StrToInt(S),StrToInt(N)));
        2: hListe.insertFirst(TReal.create(StrToFloat(S)));
        3: hListe.insertFirst(TString.create(S));
        end;
        anzeigen;
      except
          on EConvertError do
            case FormEinlesen.Radiogroup1.Itemindex of
              0:showmessage('Keine ganze Zahl');
              1:showmessage('Keine Dezimalzahl');
            end;
        end;
    end;
end;

procedure TFVerwaltung.BtGetElementClick(Sender: TObject);
var
  P:TSortElement;
  Fehler:boolean;
begin
   Fehler := False;
   P:=TSortElement(hListe.GetElement);
   with FormAusgabe do begin
     EdInteger.Text:='';
     EdBruch.Text:='';
     EdReal.text:='';
     EdString.Text:='';
     if P is TInteger then EdInteger.Text:=P.GetText
     else if P is TReal then EdReal.Text:=P.GetText
          else if P is TString then EdString.Text:=P.GetText
               else if P is TBruchzahl then EdBruch.Text := P.GetText
               else Fehler:=true;
     if not Fehler then
         ShowModal
    end (* of with *)
end;


procedure TFVerwaltung.BtDeleteNextClick(Sender: TObject);
begin
  //TLinListNode(hListe.GetElement).ReadSucc.destroy;
  hListe.deleteNext;
  anzeigen;
end;

procedure TFVerwaltung.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  hListe.Destroy;
  showmessage('Auf Wiedersehen')
end;

procedure TFVerwaltung.BtDeleteAllClick(Sender: TObject);
begin
   hListe.DeleteAll;
   anzeigen
end;

procedure TFVerwaltung.BtDeleteFirstClick(Sender: TObject);
begin
   hListe.DeleteFirst;
   anzeigen
end;

end.
