unit USortElement;

interface

uses classes;

type TSortElement = class(TObject)
     public
       (* Abstrakte Methoden *)
       function GetText: String; virtual; abstract;
       (* Methode nur zur Ausgabe auf dem Bildschirm *)

       function GreaterThan (Elem: TSortElement): Boolean; virtual; abstract;
       function Equal (Elem: TSortElement): Boolean;
       function LessThan (Elem: TSortElement): Boolean;
       function GreaterOrEqual (Elem: TSortElement): Boolean;
       function LessOrEqual (Elem: TSortElement): Boolean;
       function NotEqual (Elem: TSortElement): Boolean;
     end;

implementation

function TSortElement.Equal (Elem: TSortElement): Boolean;
begin
   result := NOT self.GreaterThan(elem) AND NOT Elem.GreaterThan(self)
end;

function TSortElement.LessThan (Elem: TSortElement): Boolean;
begin
   result := NOT self.Equal(Elem) AND NOT self.GreaterThan(Elem)
end;

function TSortElement.GreaterOrEqual (Elem: TSortElement): Boolean;
begin
   result := self.GreaterThan(Elem) OR self.Equal(Elem)
end;

function TSortElement.LessOrEqual (Elem: TSortElement): Boolean;
begin
   result := self.LessThan(Elem) OR self.Equal(Elem)
end;

function TSortElement.NotEqual (Elem: TSortElement): Boolean;
begin
   result := NOT self.Equal(Elem)
end;


end.
 