unit UStapelVerwaltung;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,
//  UStapel_ListNode;
//  UStapel_HAT_DVListe;
  UStapel_IST_DVListe;

type TElement = class (TObject)
       private
         Wert: String;
       public
         constructor Create; virtual;
         destructor Destroy; override;
         procedure SetWert (W: string);
         function GetWert: string;
     end;

type
  TForm1 = class(TForm)
    BtStapelErzeugen: TButton;
    BtEinfuegen: TButton;
    BtErstesZeigen: TButton;
    BtLoeschen: TButton;
    LBoxStapel: TListBox;
    EdElement: TEdit;
    LbElement: TLabel;
    BtNachRechts: TButton;
    LBoxStapelInvers: TListBox;
    BtNachLinks: TButton;
    procedure BtStapelErzeugenClick(Sender: TObject);
    procedure BtEinfuegenClick(Sender: TObject);
    procedure BtNachRechtsClick(Sender: TObject);
    procedure BtLoeschenClick(Sender: TObject);
    procedure BtErstesZeigenClick(Sender: TObject);
    procedure BtNachLinksClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    Stapel: TStapel;
    StapelInvers: TStapel;
    procedure Init;
  end;

var Form1: TForm1;

implementation

{$R *.DFM}

(********************* TElement: String-Objekte *******************************)

constructor TElement.Create;
begin
  inherited Create
end;

destructor TElement.Destroy;
begin
  inherited Destroy
end;

procedure TElement.SetWert (W: string);
begin
  Wert := W
end;

function TElement.GetWert: string;
begin
  GetWert := Wert
end;


(*************************  Hauptmodul  ***************************************)

procedure TForm1.Init;
var I: integer; Elem: TElement;
begin
  for I := 1 to 7 do begin
    Elem := TElement.Create;
    Elem.SetWert (IntToStr(I));
    Stapel.Push (Elem);
    LBoxStapel.Items.Insert (0,Elem.GetWert);
  end;
end;

(**********************  Ereignis-Methoden  **********************************)

procedure TForm1.BtStapelErzeugenClick(Sender: TObject);
begin
  BtEinfuegen.Visible := True;
  BtErstesZeigen.Visible := True;
  BtLoeschen.Visible := True;
  BtNachRechts.Visible := TRue;
  BtNachLinks.Visible := TRue;
  EdElement.Visible := True;
  LbElement.Visible := True;
  BtStapelErzeugen.Enabled := False;
  Stapel := TStapel.Create;
  StapelInvers := TStapel.Create;
  Init
end;

procedure TForm1.BtEinfuegenClick(Sender: TObject);
var Elem: TElement;
begin
  LbElement.Caption := 'Neues Element:';
  if Length(EdElement.Text) > 0
    then begin
      Elem := TElement.Create;
      Elem.SetWert (EdElement.Text);
      Stapel.Push (Elem);
      Elem := TElement(Stapel.Top);
      EdElement.Text := Elem.GetWert;
      LBoxStapel.Items.Insert (0,Elem.GetWert);
      EdElement.Text := ''
    end;
end;

procedure TForm1.BtNachRechtsClick(Sender: TObject);
var Elem: TElement;
begin
  if not Stapel.IsEmpty
    then begin
      Elem := TElement(Stapel.Top);
      StapelInvers.Push (Elem);
      Stapel.Pop;
      LBoxStapel.Items.Delete (0);
      LBoxStapelInvers.Items.Insert
         (0,Elem.GetWert);
    end;
end;

procedure TForm1.BtNachLinksClick(Sender: TObject);
var Elem: TElement;
begin
  if not StapelInvers.IsEmpty
    then begin
      Elem := TElement(StapelInvers.Top);
      StapelInvers.Pop;
      Stapel.Push (Elem);
      LBoxStapelInvers.Items.Delete (0);
      LBoxStapel.Items.Insert (0,Elem.GetWert);
    end;
end;

procedure TForm1.BtLoeschenClick(Sender: TObject);
var Elem: TElement;
begin
  if not Stapel.Isempty
    then begin
      Elem := TElement(Stapel.Top);
      LbElement.Caption := 'Gelschtes Element:';
      EdElement.Text := Elem.GetWert;
      Stapel.Pop;
      LBoxStapel.Items.Delete(0);
    end;
end;

procedure TForm1.BtErstesZeigenClick(Sender: TObject);
var Elem: TElement;
begin
  if not Stapel.Isempty then begin
     LbElement.Caption := 'Oberstes Element:';
     Elem := TElement(Stapel.Top);
     EdElement.Text := Elem.GetWert
  end   
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var elem:TObject;
begin
   while not stapel.isempty do begin
      elem := stapel.top;
      stapel.pop;
      elem.destroy
   end;
   stapel.destroy;
   while not stapelinvers.isempty do begin
      elem := stapelinvers.top;
      stapelinvers.pop;
      elem.destroy
   end;
   stapelinvers.destroy;

end;

end.
