unit UStapel_ListNode;

interface

uses Classes, SysUtils, UListNode;

type
  TStapel = class (TObject)
    private
      count:Integer;
      dummy:TListNode;
    public
      constructor Create;
      destructor  Destroy; override;

      procedure Push (Element: TObject); virtual;
      procedure Pop; virtual;
      function  Top: TObject; virtual;
      function  isempty:Boolean; virtual;
    end;

implementation

(****************************  TStapel  ***************************************)

constructor TStapel.Create;
begin
   dummy := TListNode.create(nil);
   dummy.writePred(dummy);
   dummy.writeSucc(dummy);
   count := 0;
end;

destructor TStapel.Destroy;
begin
   dummy.destroy;
   dummy := nil
end;

procedure TStapel.Push (Element: TObject);
var newNode: TListNode;
begin
   NewNode:=TListNode.Create(Element);
   NewNode.WritePred(dummy);
   NewNode.WriteSucc(dummy.ReadSucc);
   dummy.writeSucc(NewNode);
   NewNode.ReadSucc.WritePred(NewNode);
   inc(count)
end;

procedure TStapel.Pop;
var topNode:TListNode;
begin
  if not isempty then begin
     topNode:= dummy.ReadSucc;
     dummy.writeSucc(topNode.ReadSucc);
     topNode.ReadSucc.WritePred(dummy);
     // topNode.destroy;
     topNode:=nil;
     dec(count)
  end
end;

function TStapel.Top: TObject;
begin
  Top := dummy.ReadSucc.ReadValue
end;

function TStapel.isempty: Boolean;
begin
  result:= count=0
end;

end.

