unit USchlangentest;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,
  USchlange_HAT_TdvList;
//  USchlange_IST_TdvList;
//  USchlange_TdvListNode;
type TElement = class (TObject)
     private
       Wert: String;
     public
       constructor Create; virtual;
       destructor Destroy; override;
       procedure SetWert (W: string); virtual;
       function GetWert: string; virtual;
     end;

type
  TForm1 = class(TForm)
    BtSchlangeErzeugen: TButton;
    BtEinfuegen: TButton;
    BtErstesZeigen: TButton;
    BtLoeschen: TButton;
    LBoxSchlange: TListBox;
    EdElement: TEdit;
    LbElement: TLabel;
    BtRotieren: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure BtSchlangeErzeugenClick(Sender: TObject);
    procedure BtEinfuegenClick(Sender: TObject);
    procedure BtLoeschenClick(Sender: TObject);
    procedure BtErstesZeigenClick(Sender: TObject);
    procedure BtRotierenClick(Sender: TObject);
  private
    Schlange: TSchlange;
    procedure Init;
   end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(********************* TElement: String-Objekte *******************************)

constructor TElement.Create;
begin
  inherited Create
end;

destructor TElement.Destroy;
begin
  inherited Destroy
end;

procedure TElement.SetWert (W: string);
begin
  Wert := W
end;

function TElement.GetWert: string;
begin
  GetWert := Wert
end;

procedure TForm1.Init;
var i: integer; Elem: TElement;
begin
  for i := 1 to 7 do begin
    Elem := TElement.Create;
    Elem.SetWert(IntToStr(i+3*(i-1)));
    Schlange.Enqueue (Elem);
    LBoxSchlange.Items.Add(Elem.GetWert);
  end;
end;

(**********************  Ereignis-Methoden  **********************************)

procedure TForm1.BtSchlangeErzeugenClick(Sender: TObject);
begin
  BtEinfuegen.Visible := True;
  BtErstesZeigen.Visible := True;
  BtLoeschen.Visible := True;
  BtRotieren.Visible := True;
  EdElement.Visible := True;
  LbElement.Visible := True;
  BtSchlangeErzeugen.Visible := False;
  Schlange := TSchlange.Create;
  Init;
end;

procedure TForm1.BtEinfuegenClick(Sender: TObject);
var Elem: TElement;
begin
  LbElement.Caption := 'Neues Element';
  if Length(EdElement.Text) > 0
    then begin
      Elem := TElement.Create;
      Elem.SetWert(EdElement.Text);
      Schlange.Enqueue(Elem);
      LBoxSchlange.Items.Add (Elem.GetWert);
      Elem := TElement (Schlange.Front);
      EdElement.Text := Elem.GetWert;
    end;
end;

procedure TForm1.BtLoeschenClick(Sender: TObject);
var Elem: TElement;
begin
  if not Schlange.Isempty
    then begin
      LbElement.Caption := 'gelschtes Element';
      Elem := TElement(Schlange.Front);
      EdElement.Text := Elem.GetWert;
      Schlange.Dequeue;
      LBoxSchlange.Items.Delete(0);
    end;
end;

procedure TForm1.BtErstesZeigenClick(Sender: TObject);
var Elem: TElement;
begin
  if not Schlange.IsEmpty
    then begin
      LbElement.Caption := 'Erstes Element';
      Elem := TElement(Schlange.Front);
      EdElement.Text := Elem.GetWert;
    end
    else EdElement.Text := ''
end;

procedure TForm1.BtRotierenClick(Sender: TObject);
var Elem: TElement;
begin
  if not Schlange.IsEmpty
    then begin
      LbElement.Caption := 'Rotiertes Element';
      Elem := TElement(Schlange.Front);
      EdElement.Text := Elem.GetWert;
      Schlange.Dequeue;
      Schlange.Enqueue(Elem);
      LBoxSchlange.Items.Delete(0);
      LBoxSchlange.Items.Add(Elem.GetWert);
    end;
end;

end.
