unit UDVListe;

interface

uses sysutils, classes, dialogs,stdctrls, UListNode;

type TdvListe = class(TObject)
     private
       Count,Index:integer;
       Dummy, ActualNode:TListNode;
     public
       constructor Create; virtual;
       destructor Destroy; override;
       procedure insert (Element: TObject); virtual;
       function Add (Element: TObject): integer; virtual;
       procedure Delete; virtual;
       procedure DeleteAll; virtual;
       procedure First; virtual;
       procedure Last; virtual;
       procedure Next; virtual;
       procedure Previous; virtual;
         function isfirst: boolean;virtual;
         function islast: boolean; virtual;
         function GetElement: TObject; virtual;
         function GetCount: integer; virtual; (*keine Listenmethode!!*)
         function GetIndex:integer;virtual;   (*keine Listenmethode!!*)
         function isempty: Boolean; virtual;
     end;

implementation

constructor TdvListe.Create;
begin
    dummy:=TListnode.Create(nil);
    count := 0;
    Dummy.WriteSucc(Dummy);
    Dummy.WritePred(Dummy);
    ActualNode:=Dummy;
    Index:=0;
 end;

destructor TdvListe.Destroy;
 begin
   while not isempty do begin
     delete;
   end;
   Dummy.destroy;
   dummy:=nil;
 end;

function TdvListe.Add (Element: TObject): integer;
var
   newNode:TListnode;
 begin
   newNode:=TListnode.Create(Element);
   (* Zuerst wird der neue Knoten vor dem Dummy eingekettet *)
      (* 1 *) dummy.ReadSucc.WritePred(newNode);
              (* neu wird Nachfolger des bisher letzten Knotens *)
      (* 2 *) newNode.WriteSucc(dummy.ReadSucc);
              (* Nachfolger von neu wird der bisherige Nachfolger *)
      (* 3 *) newNode.WritePred(dummy);
              (*Vorgnger von neu wird der bisherige Nachfolgende angehngt *)
      (* 4 *) dummy.WriteSucc(newNode);
              (*neu wird vorne an den Nachfolger gehngt *)
   (*Nach dem Einketten wird das Neue Element zum aktuellen Element *)
      (* 5 *) ActualNode := newNode;
   Inc(count);
   Index := 1;
   result := count;
 end;

procedure TdvListe.Insert (Element: TObject);
var
   newNode:TListnode;
 begin
   newNode:=TListnode.Create(Element);
   (* Zuerst wird der neue Knoten vor dem aktuellen Knoten eingekettet *)
      (* 1 *) ActualNode.ReadSucc.WritePred(newNode);
              (* Das neue Element wird Nachfolger des bisherigen Vorgngers *)
      (* 2 *) newNode.WritePred(ActualNode);
              (* Der bisherige Vorgnger wird Vorgnger des neuen Knotens *)
      (* 3 *) newNode.WriteSucc(ActualNode.ReadSucc);
              (* der bisher aktuelle Knoten wird Nachfolger des neuen Knotens *)
      (* 4 *) ActualNode.WriteSucc(newNode);
              (* der Neue Knoten wird Vorgnger des aktuellen Knotens *)
    (* Dann wird das neue Element zum aktuellen Knoten *)
      ActualNode := newNode;
   Inc(count); Inc(Index);
 end;

procedure TdvListe.Delete;
 var
   P:TListNode;
 begin
   if count=0 then showmessage('Delete bei leerer Liste')
   else begin
      if Index=0 then showmessage('Delete auf Dummy')
      else begin
         ActualNode.ReadPred.WriteSucc(ActualNode.ReadSucc);
         ActualNode.ReadSucc.WritePred(ActualNode.ReadPred);
         P:=ActualNode;
         ActualNode:=ActualNode.ReadSucc;
         Dec(count);
         if Index>count then begin
            Index:=count;
            ActualNode:=ActualNode.ReadPred    (* <<--- !!! WICHTIG !!!   *)
            (* sonst zeigt ActualNode auf den Dummy , was ein FEHLER wre *)
         end;
      end
   end
end;

 procedure TdvListe.deleteall;
 begin
   while not isempty do
     delete;
 end;

procedure TdvListe.First;
begin
   ActualNode := Dummy.ReadSucc;
   Index := 1
end;

procedure TdvListe.Last;
begin
   ActualNode := Dummy.ReadPred;
   Index := count
end;

procedure TdvListe.Next;
 begin
   if Index=Count then showmessage ('Next am Listenende')
   else begin
      ActualNode := ActualNode.ReadSucc;
      Inc(Index);
   end
end;

procedure TdvListe.Previous;
begin
   if index = 1 then showmessage('Previous am Listenanfang')
   else begin
      ActualNode := ActualNode.ReadPred;
      Dec(Index)
   end
end;

function  TdvListe.GetElement: TObject;
begin
   if count=0 then 
        showmessage('Get bei leerer Liste')
   else if Index=0 then showmessage('Get auf Dummy')
        else result := ActualNode.readValue
 end;

function TdvListe.GetIndex: Integer;
   begin
       GetIndex := Index
   end ;

function TdvListe.isempty: Boolean;
  begin
      isempty := (count=0)
  end;

function TdvListe.isfirst: boolean;
  begin
     isfirst:= (Index=1)
  end;

function TdvListe.islast: boolean;
  begin
     islast:= (Index=count)
  end;

function TdvListe.Getcount: integer;
  begin
     GetCount:= count
  end;

{procedure TdvListe.Show;
var merk: Integer;
    aktuell:TSortElement;
begin
    merk := Index;
    Listbox.Items.Clear;
    if not empty then begin
       first;
       while not islast do begin
         aktuell := TSortElement(GetElement);
         if merk <> Index then
            Listbox.Items.Add ('     '+aktuell.getText)
         else
            Listbox.Items.Add ('--> '+aktuell.getText);
         next;
       end;(*of while not is last*)
       aktuell := TSortElement(GetElement);
         if merk <> Index then
            Listbox.Items.Add ('     '+aktuell.getText)
         else
            Listbox.Items.Add ('--> '+aktuell.getText);
       first;
       while merk <> Index do
          next ;
   end;
   showmessage('Anzeige aus UdvListe')
end;}



end.
