unit UListen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    EndeButton: TButton;
    BTextHinzu: TButton;
    AnzeigeButton: TButton;
    TextEdit: TEdit;
    BTextEinfuegen: TButton;
    RVorneHinten: TRadioGroup;
    RBVorne: TRadioButton;
    RBHinten: TRadioButton;
    BListeLoeschen: TButton;
    StatusBar1: TStatusBar;
    MAnzeige: TMemo;
    BZahlHinzu: TButton;
    BZahlEinfuegen: TButton;
    BFirst: TButton;
    BBw: TButton;
    BFw: TButton;
    BLast: TButton;
    EAktuell: TEdit;
    LAktuell: TLabel;
    BElementLoeschen: TButton;
    procedure EndeButtonClick(Sender: TObject);
    procedure BObjektHinzuClick(Sender: TObject);
    procedure AnzeigeButtonClick(Sender: TObject);
    procedure EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BListeLoeschenClick(Sender: TObject);
    procedure BTextEinfuegenClick(Sender: TObject);
    procedure NavigierenButtonClick (Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BElementLoeschenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
uses UListe, UElemente;
{$R *.DFM}
var Liste: TListe;

procedure Anfangswerte;
var PStr: TObjString;
begin
  PStr := TObjString.Create;
  PStr.Inhalt := 'Eins';
  Liste.Add (PStr);
  PStr := TObjString.Create;
  PStr.Inhalt := 'Zwei';
  Liste.Add (PStr);
  PStr := TObjString.Create;
  PStr.Inhalt := 'Drei';
  Liste.Add (PStr);
  PStr := TObjString.Create;
  PStr.Inhalt := 'Vier';
  Liste.Add (PStr);
  PStr := TObjString.Create;
  PStr.Inhalt := 'Sechs';
  Liste.Add (PStr);
  PStr := TObjString.Create;
  PStr.Inhalt := 'Acht';
  Liste.Add (PStr);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Liste := TListe.Create;
  StatusBar1.SimpleText := Format(' %d Byte',[GetHeapStatus.TotalAllocated]);
  Anfangswerte;
  AnzeigeButtonClick(nil);
end;

procedure TForm1.BListeLoeschenClick(Sender: TObject);
begin
  Liste.Free;
  Liste := TListe.Create; // keine elegante Lsung!
  StatusBar1.SimpleText := Format(' %d Byte',[GetHeapStatus.TotalAllocated])
end;

procedure TForm1.NavigierenButtonClick (Sender: TObject);
begin
  if Sender = BFirst then Liste.First
   else if Sender = BBw then Liste.Bw
         else if Sender = BFw then Liste.Fw
               else if Sender = BLast then Liste.Last;
  EAktuell.Text := (Liste.Get).Get
end;

procedure TForm1.EndeButtonClick(Sender: TObject);
begin
  Liste.Free;
  close
end;

procedure TForm1.BObjektHinzuClick(Sender: TObject);
var PStr: TObjString;
begin
 if Sender = BTextHinzu then begin
  PStr := TObjString.Create;
  PStr.Inhalt := TextEdit.Text;
  if RBVorne.checked = true then Liste.Insert (PStr,0) else Liste.Add (PStr);
 end else begin
 end;
 AnzeigeButtonClick(Sender);
 StatusBar1.SimpleText := Format(' %d Byte',[GetHeapStatus.TotalAllocated])
end;

procedure TForm1.AnzeigeButtonClick(Sender: TObject);
var i: integer;
begin
  MAnzeige.Clear;
  if Liste.Count > 0 then
  for i := 0 to Liste.Count-1 do
   begin
     MAnzeige.Lines.Add(Liste.Items[i].Get);
   end else MAnzeige.Lines.Add('Liste ist leer!');
end;

procedure TForm1.EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = 13) then begin
//    if Sender = TextEdit then BTextHinzuClick(Sender)
  end;
//  AnzeigeButtonClick(Sender);
end;

procedure TForm1.BTextEinfuegenClick(Sender: TObject);
var Eingabe: string;
    PStr: TObjString;
    Index: integer;
begin
  if InputQuery ('Einfgestelle','An welcher Stelle 0-'+ IntToStr(Liste.Count-1)+
                  'soll eingefgt werden?',Eingabe)
   then begin
     try
      Index := StrToInt(Eingabe);
      if Sender = BTextEinfuegen then begin
      end else begin
       if (MessageDlg('Soll der Index '+IntToStr(Index)+' ersetzt werden?',
                     mtConfirmation, [mbYes, mbNo],0)=mrYes)
        then
       ;// else
        AnzeigeButtonClick(Sender);
       end;
      except
       on EConvertError do ShowMessage ('Bitte ganze Zahl eingeben!');
       on EIndexTooLarge do ShowMessage ('Index nicht gltig!');
     end;
   end;
end;

procedure TForm1.BElementLoeschenClick(Sender: TObject);
begin
  Liste.Delete
end;

end.
