unit UListTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    ListeZeigenButton: TButton;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure ListeZeigenButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

  TListe = class(TList)
    procedure Sortiere;
    procedure Speichere (Dateiname: string);
    procedure Lade (Dateiname: string);
  end;
var
  Form1: TForm1;

implementation
uses UFiguren;
{$R *.DFM}
const maxzahl = 20;

var
  Liste: TListe;
  Temp: String;
  AList: tList;
  APolygon: pPolygon;
  AArcus: PArc;
  ACircle: pCircle;
  Ptr: pVater;
  p,q, r, s :tPunkt;

procedure HeapStatus(StatusMessage: String);
begin
//  Str(MemAvail: 6, Temp);
//  OutTextLn(StatusMessage+Temp);
end;

procedure TListe.Sortiere;
begin
//  Sort(AnsiStrComp);
end;

procedure TListe.Speichere (Dateiname: string);
begin
end;

procedure TListe.Lade (Dateiname: string);
begin
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: word;
begin
  Liste := TListe.Create;
  Liste.Clear;
  Liste.Capacity := maxzahl;
//  for i := 0 to maxzahl do
//    Liste.Add(pointer(1+random(100)));
//  Liste.Sortiere;
end;

procedure TForm1.ListeZeigenButtonClick(Sender: TObject);
var i: word;
begin
  Memo1.Clear;
//  for i := 0 to maxzahl do
//    Memo1.Lines.Add(inttostr(word(Liste.Items[i])));

  { Neue Liste erstellen }

  AList.Init;

  { Einige Figuren erzeugen und sie der Liste hinzufgen
    Die Syntax von NEW ist um einen Parameter erweitert;
    z.B. NEW(pArc, Init(151,82,25,200,330) entspricht
         NEW(pArc);    pArc.Init(151,82,25,200,330)
    Diese erweiterte Syntax von NEW ist notwendig, da bei vor-
    stehender Reihenfolge die Instanz AArc beim Aufruf von NEW
    noch gar nicht vorhanden ist - der Speicherbedarf auf dem
    Heap also noch nicht bekannt ist.
    Achtung: der erste Parameter mu ein Zeiger-Typ sein und nicht
             wie bisher eine Zeiger-Variable
  }
  AList.Add(pVater(tTriangle.Init(99,301,141,301,221,240)));
  AList.Add(pVater(tQuadrat.Init(188,290,50)));
  AList.Add(pVater(tArc.Init(181, 182, 25, 200, 330)));
  AList.Add(pVater(tCircle.Init(400, 200, 40)));
  AList.Add(pVater(tCircle.Init(305, 236, 5)));

//  APolygon := tPolygon.Init;

  p.Init(350,273); q.Init(360,320); r.Init(390,360); s.Init(430,300);

  APolygon^.AddStrecke(p,q);
  APolygon^.AddStrecke(q,r);
  APolygon^.AddStrecke(r,s);
  APolygon^.AddStrecke(s,p);

  AList.Add(pVater(APolygon));
  AList.Report;

  { Leere Liste und zeige Objekte }

  OutTextLn('Liste leer machen und Objekte zeigen');
  repeat
   AList.Sub (Ptr);
   OutText('Umfang des Objekts '); OutReal(Ptr^.Umfang); OutTextLn('');
   Ptr^.zeige; readln;
  until AList.IsEmpty;
  readln;

  HeapStatus('Speicherplatz auf dem Heap nachdem List aufgerufen ist: ');

  { Beseitigung der ganzen Liste mit einem destructor-Aufruf }

  AList.Done;

  HeapStatus('Heap-Speicher nach Entfernung: ');

  OutText('Enter um das Programm zu beenden: ');

end;

end.

